import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class farmCell here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class farmCell extends Actor
{
    /**
     * Act - do whatever the farmCell wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int imgNo=0;       //紀錄圖檔案字串
    private int upper=0;       //紀錄四個方向的出口是否可連通其他方格
    private int bottom=0;
    private int left=0;
    private int right=0;
    private int connect=0;
    
    public farmCell(int imgNo, int upper, int bottom, int left, int right)
    {
       this.imgNo=imgNo;
       this.upper=upper;
       this.bottom=bottom;
       this.left=left;
       this.right=right;
       setImage("spr"+this.imgNo+".png");
    }
    
    /**
     * 將成員變數組合成長度為5的陣列回傳出去
     */
    public int[] getValue()
    {
        int[] value={imgNo,upper,bottom,left,right};
        return value;
    }
    
    /**
     * 偵測四個方向的連通點
     */
    public void checkCell()
    {
        farmland fl=(farmland)getWorld();
        if (getConnect()==0)  //如果本方格之前尚未連通過
        {
            setConnect();  //先連通
            setImage("wspr"+imgNo+".png");  //改變成充滿水的圖檔
            fl.addConnectCount();   //整體連通的方格數加1
            if (upper==1)  //如果可以連到上方
            {
                if(getY()!=2)  //同時該方格又不在最上方
                {
                    //則檢查此方格的上方連通點之下方是否有開口
                    farmCell temp=(farmCell)getOneObjectAtOffset(0,-1,farmCell.class);
                    if (temp.getValue()[2]==1) //如果有則也要進行判斷
                    {
                        temp.checkCell();
                    }
                }
             }
            if(bottom==1)
            {
                if(getY()!=7)
                {
                    farmCell temp=(farmCell)getOneObjectAtOffset(0,1,farmCell.class);
                    if (temp.getValue()[1]==1)
                    {
                        temp.checkCell();
                    }
                }
            }
            if(left==1)
            {
                if(getX()!=5)
                {
                    farmCell temp=(farmCell)getOneObjectAtOffset(-1,0,farmCell.class);
                    if (temp.getValue()[4]==1)
                    {
                        temp.checkCell();
                    }
                }
            }
            if(right==1)
            {
                if(getX()!=10)
                {
                    farmCell temp=(farmCell)getOneObjectAtOffset(1,0,farmCell.class);
                    if (temp.getValue()[3]==1)
                    {
                        temp.checkCell();
                    }
                }
            }
        }
        else
        {
            return;
        }
    }
    
    /**
     * 改變已連通的狀態
     */
    public void setConnect()
    {
        connect=1;
    }
    
    /**
     * 回傳目前的連通狀態
     */
    public int getConnect()
    {
        return connect;
    }
    
    public void act() 
    {
        // Add your action code here.
    }    
}
